﻿using System;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.JavaScript;
using System.ComponentModel.DataAnnotations;
using System.Collections;
using System.Threading.Tasks;
using System.Net;
using Microsoft.AspNetCore.Mvc;

namespace WebApplication8.Controllers
{
    public class HomeController : Controller
    {
        public static List<Orders> order = new List<Orders>();
        public void BindDataSource()
        {
            int code = 10000;
            for (int i = 1; i < 10; i++)
            {
                order.Add(new Orders(code + 1, "ALFKI", i + 0, 2.3 * i, new DateTime(1991, 05, 15), "Berlin"));
                order.Add(new Orders(code + 2, "ANATR", i + 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid"));
                order.Add(new Orders(code + 3, "ANTON", i + 1, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester"));
                order.Add(new Orders(code + 4, "BLONP", i + 3, 5.3 * i, new DateTime(1930, 10, 22), "Marseille"));
                order.Add(new Orders(code + 5, "BOLID", i + 4, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen"));
                code += 5;
            }
        }
        public class Orders
        {
            public Orders()
            {

            }
            public Orders(long OrderId, string CustomerId, int EmployeeId, double Freight, DateTime OrderDate, string ShipCity)
            {
                this.OrderID = OrderId;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.ShipCity = ShipCity;
            }

            [Range(0, int.MaxValue, ErrorMessage = "OrderID must be greater than 0.")]
            public long OrderID { get; set; }

            [StringLength(5, ErrorMessage = "CustomerID must be 5 characters.")]
            public string CustomerID { get; set; }
            public int EmployeeID { get; set; }
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }

            [StringLength(15, ErrorMessage = "ShipName must be 15 characters.")]
            public string ShipCity { get; set; }
        }
        public IActionResult Index()
        {
            BindDataSource();
            ViewBag.data = order;
            return View();
        }
        public ActionResult Update([FromBody]CRUDModel<Orders> myObject)
        {
            if (ModelState.IsValid)
            {
                var ord = myObject.Value;
                Orders val = order.Where(or => or.OrderID == ord.OrderID).FirstOrDefault();
                val.OrderID = ord.OrderID;
                val.EmployeeID = ord.EmployeeID;
                val.CustomerID = ord.CustomerID;
                val.Freight = ord.Freight;
                val.OrderDate = ord.OrderDate;
                val.ShipCity = ord.ShipCity;

                return Json(myObject.Value);
            }
            if (!ModelState.IsValid)
            {
                var message = string.Join(" | ", ModelState.Values
             .SelectMany(v => v.Errors)
             .Select(e => e.ErrorMessage));
                
                return new StatusCodeResult(0);
            }
            return View();
        }
        public ActionResult Create([FromBody]CRUDModel<Orders> value)
        {
            value.Value.OrderID = order.LastOrDefault().OrderID + 1;
            order.Insert(0, value.Value);
            return Json(value);
        }
        public ActionResult Delete([FromBody]CRUDModel<Orders> value)
        {
            order.Remove(order.Where(or => or.OrderID == int.Parse(value.Key.ToString())).FirstOrDefault());
            return Json(value);
        }
        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View();
        }
    }
}
